﻿// COSC 4P76 - Assignment 1
// Michael Gircys (mg12vp, 5269550)
// 2016-03-01

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace KMeansClusterer
{
    // Extensions to various array structures and enumerables
    public static class ArrayExtensions
    {
        // Provide output text as MATLAB-style vectors
        public static String ArrayString<T>(this IEnumerable<T> arr)
        {
            var sb = new StringBuilder();
            sb.Append("[ ");
            var count = arr.Count();
            for(int i = 0; i < count; i++)
                sb.Append( arr.ElementAt(i).ToString() + ((i==count-1) ? "" : ", ") );
            sb.Append(" ]");
            return sb.ToString();
        }

        // Convert 2-d jagged array structure to new type
        public static double[][] CopyDoubleStructure<T1>(this T1[][] arr)
        {
            var dimen1 = arr.Count();
            var output = new double[dimen1][];
            for(int i = 0; i < dimen1; i++)
                output[i] = new double[arr[i].Length];
            return output;
        }
        // Something strange was going on with generic casting and jagged arrays
        //public static T2[][] CopyStructure<T1,T2>(this T1[][] arr, T2 type)
        //{
        //    var dimen1 = arr.Count();
        //    T2[][] output = new T2[dimen1][];
        //    for(int i = 0; i < dimen1; i++)
        //    {
        //        T2[] elem = new T2[arr[i].Length];
        //        output[i] = elem;
        //    }
        //    return output;
        //}

        // Rearrange the rows of the enumerable in a random order
        public static IEnumerable<T> Shuffle<T>(this IEnumerable<T> list)
        {
            List<T> shuffled = new List<T>();
            var listSize = list.Count();
            var ordering = new int[listSize];

            for(int i = 0; i < listSize; i++)
                ordering[i] = i;
            for(int i = 0; i < listSize; i++)
            {
                var j = RandomGenerator.Get().Next(listSize);
                var t = ordering[i];
                ordering[i] = ordering[j];
                ordering[j] = t;
            }
            for(int i = 0; i < listSize; i++)
                shuffled.Add(list.ElementAt(ordering[i]));

            return shuffled;
        }

    }
}
