﻿// COSC 4P76 - Assignment 2
// Michael Gircys (mg12vp, 5269550)
// 2016-03-13

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace KMeansClusterer
{
    // Singleton style random generator w/ specificable seed
    // There can be many Randoms, but only 1 from the common RandomGenerator.
    public static class RandomGenerator
    {
        private static Random          _Instance;
        private static Nullable<Int32> _LastSeed;

        public static Random Get()
        {
            if(_Instance==null) Initialize();
            return _Instance;
        }

        public static void Initialize(bool useLastSeed = true)
        {
            if(_LastSeed.HasValue && useLastSeed)
                    _Instance = new Random(_LastSeed.Value);
            else    _Instance = new Random();
        }
        public static void Initialize(int seed)
        {
            _LastSeed = seed;
            Initialize();
        }

        // Extend to get random double in range.
        public static double NextDouble( this Random r, double min, double max )
        {
            var rv = r.NextDouble();
            return ((max-min)*rv) + min;
        }

    }
}
